using CadEditor;
using System;
using PluginMapEditor;

public class HorizonUtils
{
    public static OffsetRec getScrOffet()
  {
    return ConfigScript.screensOffset[0];
  }
  
    public static MapData[] loadMap(int mapNo)
  {
      int w = getScrOffet().width * 2;
      int h = getScrOffet().height * 2;
      var mapData = MapUtils.loadMapFromBlocks(mapNo, w*h, w*h/12, h, true, fillAttribsT);
      return mapData;
  }
 
  
  
  public static MapInfo[] makeMapsInfo()
  {
     var mapsInfo = new MapInfo[getScrOffet().recCount];
     int scrSize = getScrOffet().width * getScrOffet().height * ConfigScript.getWordLen();
     for (int i = 0; i < mapsInfo.Length; i++)
     {
         int da = getScrOffet().beginAddr + scrSize  * i;
         int aa = ConfigScript.getPalBytesAddr(0) + 64*i;
         mapsInfo[i] = new MapInfo(){ dataAddr = da, palAddr = ConfigScript.palOffset.beginAddr, videoNo = 0, attribsAddr = aa};
     }
     return mapsInfo;
  }
  
	  
  public static void fillAttribsT(int[] attrData, byte[] romdata, int attribAddr)
  {
      int HEIGHT = 8;// 8, потому что высота карты 15 блоков, но 15 / 2 = 7, но 7 не подходит, потому что аттрибутов 64, а 7*8 = 56;getScrOffet().width/2;
      int WIDTH = getScrOffet().height/2;
      for (int i = 0; i < HEIGHT*WIDTH; i++)
      {
		  int x = i % WIDTH;
          int y = i / WIDTH;
		  int pageID = x / 8;//потому что ширина карты 16 блоков, а 1 один аттрибут на 2 блока по ширине 16/2 = 8
          //int tind = y * WIDTH + x;
		  int xx = x % 8;
		  int yy = y;
		  int ind = xx * 8 + yy;
		  attrData[i] = Globals.romdata[attribAddr + ind + pageID * 64]; //64 аттрибута на всю карту 

      }
  }
  

  public static int saveAttribsT(int mapNo, MapData[] mapData, out byte[] packedData)
  {
	  packedData = new byte[0];
      int attribAddr = MapConfig.mapsInfo[mapNo].attribsAddr;

      int HEIGHT = 8;// = getScrOffet().width/2;
      int WIDTH = getScrOffet().height/2;
      for (int i = 0; i < HEIGHT * WIDTH; i++)
      {
          int x = i % WIDTH;
          int y = i / WIDTH;
		  int pageID = x / 8;
		  int xx = x % 8;
		  int yy = y;
		  int ind = xx * 8 + yy;
          Globals.romdata[attribAddr + ind + pageID * 64] = (byte)mapData[0].attrData[i];
      }
      Globals.flushToFile();
      return 0;
  }
}