using CadEditor;
using System;
using PluginMapEditor;
//css_include over_horizon/HorizonUtils.cs;
//css_include shared_settings/SharedUtils.cs;

public class Data 
{ 
  public string[] getPluginNames() 
  {
    return new string[] 
    {
      "PluginMapEditor.dll",
    };
  }
  public OffsetRec getScreensOffset()  { return new OffsetRec(0xB008, 1 , 15*128, 15, 128);}
  public bool isBigBlockEditorEnabled() { return false; }
  public bool isBlockEditorEnabled()    { return true; }
  public bool isEnemyEditorEnabled()    { return false; }
  
  public OffsetRec getVideoOffset()   { return new OffsetRec(0x0, 1, 0x1000); }
  
  public bool isBuildScreenFromSmallBlocks() { return true; }
  
  public OffsetRec getBlocksOffset()    { return new OffsetRec(0xCF1C, 1  , 0x1000);  }
  public int getBlocksCount()           { return 93; }
  public int getBigBlocksCount()        { return 93; }
  
  public GetVideoPageAddrFunc getVideoPageAddrFunc() { return SharedUtils.fakeVideoAddr(); }
  public GetVideoChunkFunc    getVideoChunkFunc()    { return SharedUtils.getVideoChunk(new[] {"ppu_dump_level_6.bin"}); }
  public SetVideoChunkFunc    setVideoChunkFunc()    { return null; }

  public int getPalBytesAddr()         { return 0xB986; }
  public bool getScreenVertical()      { return true; }
  
  public GetPalFunc getPalFunc()  { return Utils.getPalleteLinear;}
  public SetPalFunc setPalFunc()  { return Utils.setPalleteLinear;}
  public OffsetRec getPalOffset() { return new OffsetRec(0xC1E0, 1  , 16  ); }
  
  public GetBlocksFunc getBlocksFunc() { return Utils.getBlocksLinear2x2withoutAttrib;}
  public SetBlocksFunc setBlocksFunc() { return Utils.setBlocksLinearWithoutAttrib;}
  
  //-------------------------------------------------------------------------------------------------------------------
  public MapInfo[] getMapsInfo()      { return HorizonUtils.makeMapsInfo(); }
  public LoadMapFunc getLoadMapFunc() { return HorizonUtils.loadMap; }
  public SaveMapFunc getSaveMapFunc() { return HorizonUtils.saveAttribsT; }
  public bool isMapReadOnly()         { return true; }
  public bool mapEditorSharePallete() { return true; }
  //-------------------------------------------------------------------------------------------------------------------
    
}